#ifndef __PATTERN_H__
#define __PATTERN_H__

#include <stdint.h>
#include <stdbool.h>
#include "audio/replayer.h" // note_t

#define VISIBLE_ROWS 13

void Pattern_ClearCache(void);
bool Pattern_CreateDrawingCode(void);
void Pattern_FreeDrawingCode(void);
void Pattern_SetCursorPos(uint8_t cursorPos);
void Pattern_Draw(int32_t pattern);

// apattern.asm

extern void Pattern_ClearRows(int32_t startRow, int32_t numRows);
#pragma aux Pattern_ClearRows parm [EAX] [ECX];

extern void Pattern_DrawRows(int32_t endRow, int32_t drawRow, int32_t startRow, note_t *notes);
#pragma aux Pattern_DrawRows parm [EAX] [EBX] [ECX] [ESI];

#endif
