#ifndef __DISKOP_H__
#define __DISKOP_H__

#include <stdint.h>
#include <stdbool.h>

void DiskOp_Refresh(void);
bool DiskOp_SetDrive(char letter);
bool DiskOp_SetPath(const char *path);
bool DiskOp_HandleListSelection(void);
void DiskOp_ScrollUp(void);
void DiskOp_ScrollDown(void);
void DiskOp_ScrollToTop(void);
void DiskOp_ScrollToBottom(void);
void DiskOp_DrawFileList(void);
void DiskOp_Toggle(void);
void DiskOp_Open(void);
void DiskOp_Exit(void);

#endif
